#include <stdafx.h>
#include "GPIBControl.h"
#include "Decl-32.h"

CGPIBControl::CGPIBControl(){
// RXgN^
	iBoardNumber = 0;
	iAddress = 7;
	iUD = 0;
}

CGPIBControl::~CGPIBControl(){
// fXgN^
	if (iUD != 0){		// fohafoCXICłΐؒf
		ibonl(iUD,0);
	}
}

BOOL CGPIBControl::Init(int iGPIBBoardNumber,int iGPIBAddress){

	if (iGPIBBoardNumber < 0 || iGPIBBoardNumber > 3 ) return FALSE;
	if (iGPIBAddress     < 0 || iGPIBAddress     > 30) return FALSE;
	
	CString strFind;

	strFind.Format("GPIB%d",iGPIBBoardNumber);
	ibfind(strFind);
	if (ibsta & ERR) return FALSE;

	Sleep(30);

	iUD = ibdev(iGPIBBoardNumber,iGPIBAddress,0,T1s,1,0x1a0a);
	if (iUD < 0) {
		iUD = 0;
		return FALSE;
	}

	Sleep(30);
	
	for (int i=0; i<10; i++){
		short iLN;
		ibln (iUD,iGPIBAddress,0,&iLN);
		if ( (iLN != 0) && !(ibsta & ERR) ) break;
	}
	if (i == 10) return FALSE;

	return TRUE;
}

BOOL CGPIBControl::Send(CString strMessage){
//
// 񑗐M֐
//
	char cCommand[256];

	if (iUD == 0) return FALSE;
	if (strMessage == "") return FALSE;
	
	strMessage += "\r\n";
	strcpy(cCommand,strMessage); 
	Sleep(1);
	ibwrt(iUD,cCommand,strMessage.GetLength());
	return TRUE;
}

BOOL CGPIBControl::Receive(CString& strMessage){
//
// M֐
//
	char cMessage[256];

	if (iUD == 0) return FALSE;
	strMessage = "";

	Sleep(1);
	ibrd(iUD,cMessage,256);
	if (ibsta & ERR) return FALSE;
	
	strMessage = cMessage;					// Œ蒷񂩂ϒփRs[
	strMessage = strMessage.Mid(0,ibcnt-2);	// f~^܂ł
	return TRUE;
}

